> ## Documentation Index
> Fetch the complete documentation index at: https://docs.goldsky.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a pipeline

> Create and deploy a new turbo pipeline. The pipeline name must be unique within the project.



## OpenAPI

````yaml /turbo-pipelines/api/openapi.json post /pipelines/
openapi: 3.1.0
info:
  title: Goldsky API
  description: >-
    REST API for managing Goldsky pipelines. Create, deploy, monitor, and manage
    data pipelines programmatically.


    For a full introduction to Turbo Pipelines, see the [Turbo Pipelines
    documentation](https://docs.goldsky.com/turbo-pipelines/introduction).
  version: 1.0.0
  contact:
    name: Goldsky Support
    email: support@goldsky.com
    url: https://docs.goldsky.com
servers:
  - url: https://api.goldsky.com/api/v1
    description: Goldsky API
security:
  - BearerAuth: []
tags:
  - name: Pipelines
    description: >-
      Create, read, update, and delete pipelines. Manage pipeline lifecycle
      (pause, resume, restart).
  - name: Pipeline Logs
    description: Retrieve pipeline execution logs.
  - name: Pipeline Status
    description: Query pipeline runtime status and state information.
paths:
  /pipelines/:
    post:
      tags:
        - Pipelines
      summary: Create a pipeline
      description: >-
        Create and deploy a new turbo pipeline. The pipeline name must be unique
        within the project.
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  minLength: 1
                  maxLength: 50
                  pattern: ^[a-z0-9-]{1,50}$
                  description: >-
                    Pipeline name. Only lowercase letters, numbers, and hyphens
                    are allowed.
                  type: string
                resource_size:
                  type: string
                description:
                  type: string
                use_dedicated_ip:
                  type: boolean
                definition:
                  type: object
                  properties:
                    sources:
                      type: object
                      additionalProperties: {}
                    transforms:
                      type: object
                      additionalProperties: {}
                    sinks:
                      type: object
                      additionalProperties: {}
                  required:
                    - sources
                    - transforms
                    - sinks
              required:
                - name
                - definition
            example:
              name: ethereum-blocks
              resource_size: s
              use_dedicated_ip: false
              job: false
              description: Streams Ethereum blocks
              definition:
                sources:
                  my_source:
                    dataset_name: ethereum.raw_blocks
                    start_at: latest
                    type: dataset
                    version: 1.0.0
                transforms:
                  my_transform:
                    from: my_source
                    primary_key: id
                    type: handler
                    url: https://handler.com
                sinks:
                  my_sink:
                    from: my_transform
                    type: blackhole
        required: true
      responses:
        '200':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  name:
                    type: string
                  type:
                    type: string
                  status:
                    anyOf:
                      - type: string
                        enum:
                          - RUNNING
                      - type: string
                        enum:
                          - PAUSED
                      - type: string
                        enum:
                          - RESTARTING
                      - type: string
                        enum:
                          - DEPLOYING
                      - type: string
                        enum:
                          - STOPPED
                      - type: string
                        enum:
                          - FAILED
                      - type: string
                        enum:
                          - UNKNOWN
                  definition:
                    type: object
                    properties:
                      sources:
                        type: object
                        additionalProperties: {}
                      transforms:
                        type: object
                        additionalProperties: {}
                      sinks:
                        type: object
                        additionalProperties: {}
                      description:
                        type: string
                      resource_size:
                        type: string
                      use_dedicated_ip:
                        type: boolean
                      job:
                        type: boolean
                    required:
                      - sources
                      - transforms
                      - sinks
                  resource_size:
                    type: string
                  created_at:
                    format: date-time
                    type: string
                  updated_at:
                    format: date-time
                    type: string
                  version:
                    type: number
                  project_id:
                    type: string
                required:
                  - name
                  - type
                  - status
                  - definition
                  - created_at
                  - updated_at
components:
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: >-
        API token generated from the [Goldsky
        Dashboard](https://app.goldsky.com/dashboard/settings/project). Pass as:
        Authorization: Bearer <token>

````